From c562a316817091b80ac9c7d3efa31067850b03e6 Mon Sep 17 00:00:00 2001
From: Aleksander Machniak <alec@alec.pl>
Date: Wed, 18 Dec 2013 15:41:56 -0500
Subject: [PATCH] Improved minified files handling, added css minification (#1486988)

---
 CHANGELOG                              |    1 
 /dev/null                              |   14 ----
 program/include/rcmail_output_html.php |   43 ++++++++------
 bin/jsshrink.sh                        |   36 +++++++----
 bin/cssshrink.sh                       |   62 ++++++++++++++++++++
 5 files changed, 110 insertions(+), 46 deletions(-)

diff --git a/CHANGELOG b/CHANGELOG
index e3f2f58..967e2a3 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -1,6 +1,7 @@
 CHANGELOG Roundcube Webmail
 ===========================
 
+- Improved minified files handling, added css minification (#1486988)
 - Fix handling of X-Forwarded-For header with multiple addresses (#1489481)
 - Fix border issue on folders list in classic skin (#1489473)
 - Implemented menu actions to copy/move messages, added folder-selector widget (#1484086)
diff --git a/bin/cssshrink.sh b/bin/cssshrink.sh
new file mode 100755
index 0000000..604a046
--- /dev/null
+++ b/bin/cssshrink.sh
@@ -0,0 +1,62 @@
+#!/bin/sh
+PWD=`dirname "$0"`
+JAR_DIR='/tmp'
+VERSION='2.4.8'
+COMPILER_URL="https://github.com/yui/yuicompressor/releases/download/v${VERSION}/yuicompressor-${VERSION}.zip"
+
+do_shrink() {
+	rm -f "$2"
+	java -jar $JAR_DIR/yuicompressor.jar -v -o "$2" "$1"
+}
+
+if [ ! -w "$JAR_DIR" ]; then
+	JAR_DIR=$PWD
+fi
+
+if java -version >/dev/null 2>&1; then
+	:
+else
+	echo "Java not found. Please ensure that the 'java' program is in your PATH."
+	exit 1
+fi
+
+if [ ! -r "$JAR_DIR/yuicompressor.jar" ]; then
+	if which wget >/dev/null 2>&1 && which unzip >/dev/null 2>&1; then
+		wget "$COMPILER_URL" -O "/tmp/$$.zip"
+	elif which curl >/dev/null 2>&1 && which unzip >/dev/null 2>&1; then
+		curl "$COMPILER_URL" -o "/tmp/$$.zip"
+	else
+		echo "Please download $COMPILER_URL and extract compiler.jar to $JAR_DIR/."
+		exit 1
+	fi
+	(cd $JAR_DIR && unzip "/tmp/$$.zip" && mv "yuicompressor-${VERSION}.jar" "yuicompressor.jar")
+	rm -f "/tmp/$$.zip"
+fi
+
+# compress single file from argument
+if [ $# -gt 0 ]; then
+	CSS_FILE="$1"
+
+	echo "Shrinking $CSS_FILE"
+    minfile=`echo $CSS_FILE | sed -e 's/\.css$/\.min\.css/'`
+	do_shrink "$CSS_FILE" "$minfile"
+	exit
+fi
+
+DIRS="$PWD/../skins/* $PWD/../plugins/* $PWD/../plugins/*/skins/*"
+# default: compress application scripts
+for dir in $DIRS; do
+    for file in $dir/*.css; do
+        echo "$file" | grep -e '.min.css$' >/dev/null
+        if [ $? -eq 0 ]; then
+            continue
+        fi
+        if [ ! -f "$file" ]; then
+            continue
+        fi
+
+        echo "Shrinking $file"
+        minfile=`echo $file | sed -e 's/\.css$/\.min\.css/'`
+        do_shrink "$file" "$minfile"
+    done
+done
diff --git a/bin/jsshrink.sh b/bin/jsshrink.sh
index b13d7b2..f7c7b22 100755
--- a/bin/jsshrink.sh
+++ b/bin/jsshrink.sh
@@ -1,7 +1,10 @@
 #!/bin/sh
-JS_DIR=`dirname "$0"`/../program/js
+PWD=`dirname "$0"`
+JS_DIR="$PWD/../program/js"
 JAR_DIR='/tmp'
 LANG_IN='ECMASCRIPT3'
+# latest version requires Java 7, we'll use an older one
+#CLOSURE_COMPILER_URL='http://dl.google.com/closure-compiler/compiler-latest.zip'
 CLOSURE_COMPILER_URL='http://dl.google.com/closure-compiler/compiler-20131014.zip'
 
 do_shrink() {
@@ -15,7 +18,7 @@
 fi
 
 if [ ! -w "$JAR_DIR" ]; then
-	JAR_DIR=`dirname "$0"`
+	JAR_DIR=$PWD
 fi
 
 if java -version >/dev/null 2>&1; then
@@ -47,21 +50,26 @@
 		LANG_IN="$2"
 	fi
 
-	if [ ! -r "${JS_FILE}.src" ]; then
-		mv "$JS_FILE" "${JS_FILE}.src"
-	fi
 	echo "Shrinking $JS_FILE"
-	do_shrink "${JS_FILE}.src" "$JS_FILE" "$LANG_IN"
+    minfile=`echo $JS_FILE | sed -e 's/\.js$/\.min\.js/'`
+	do_shrink "$JS_FILE" "$minfile" "$LANG_IN"
 	exit
 fi
 
+DIRS="$PWD/../program/js $PWD/../skins/* $PWD/../plugins/* $PWD/../plugins/*/skins/*"
 # default: compress application scripts
-for fn in app common googiespell list treelist; do
-	if [ -r "$JS_DIR/${fn}.js.src" ]; then
-		echo "$JS_DIR/${fn}.js.src already exists, not overwriting"
-	else
-		mv "$JS_DIR/${fn}.js" "$JS_DIR/${fn}.js.src"
-	fi
-	echo "Shrinking $JS_DIR/${fn}.js"
-	do_shrink "$JS_DIR/${fn}.js.src" "$JS_DIR/${fn}.js" "$LANG_IN"
+for dir in $DIRS; do
+    for file in $dir/*.js; do
+        echo "$file" | grep -e '.min.js$' >/dev/null
+        if [ $? -eq 0 ]; then
+            continue
+        fi
+        if [ ! -f "$file" ]; then
+            continue
+        fi
+
+        echo "Shrinking $file"
+        minfile=`echo $file | sed -e 's/\.js$/\.min\.js/'`
+        do_shrink "$file" "$minfile" "$LANG_IN"
+    done
 done
diff --git a/bin/jsunshrink.sh b/bin/jsunshrink.sh
deleted file mode 100755
index ef1bb47..0000000
--- a/bin/jsunshrink.sh
+++ /dev/null
@@ -1,14 +0,0 @@
-#!/bin/sh
-JS_DIR=`dirname "$0"`/../program/js
-
-if [ ! -d "$JS_DIR" ]; then
-	echo "Directory $JS_DIR not found."
-	exit 1
-fi
-
-for fn in app common googiespell list treelist; do
-	if [ -r "$JS_DIR/${fn}.js.src" ]; then
-		mv "$JS_DIR/${fn}.js.src" "$JS_DIR/${fn}.js"
-		echo "Reverted $JS_DIR/${fn}.js"
-	fi
-done
diff --git a/program/include/rcmail_output_html.php b/program/include/rcmail_output_html.php
index 7ff85e0..e4059b7 100644
--- a/program/include/rcmail_output_html.php
+++ b/program/include/rcmail_output_html.php
@@ -662,23 +662,33 @@
 
         // add file modification timestamp
         if (preg_match('/\.(js|css)$/', $file, $m)) {
-            $fs  = false;
-            $ext = $m[1];
-
-            // use minified file if exists (not in development mode)
-            if (!$this->devel_mode && !preg_match('/\.min\.' . $ext . '$/', $file)) {
-                $minified_file = substr($file, 0, strlen($ext) * -1) . 'min.' . $ext;
-                if ($fs = @filemtime($minified_file)) {
-                    $file = $minified_file . '?s=' . $fs;
-                }
-            }
-
-            if (!$fs && ($fs = @filemtime($file))) {
-                $file .= '?s=' . $fs;
-            }
+            $file = $this->file_mod($file);
         }
 
         return $matches[1] . '=' . $matches[2] . $file . $matches[4];
+    }
+
+    /**
+     * Modify file by adding mtime indicator
+     */
+    protected function file_mod($file)
+    {
+        $fs  = false;
+        $ext = substr($file, strrpos($file, '.') + 1);
+
+        // use minified file if exists (not in development mode)
+        if (!$this->devel_mode && !preg_match('/\.min\.' . $ext . '$/', $file)) {
+            $minified_file = substr($file, 0, strlen($ext) * -1) . 'min.' . $ext;
+            if ($fs = @filemtime($minified_file)) {
+                return $minified_file . '?s=' . $fs;
+            }
+        }
+
+        if ($fs = @filemtime($file)) {
+            $file .= '?s=' . $fs;
+        }
+
+        return $file;
     }
 
     /**
@@ -1225,10 +1235,7 @@
     public function include_script($file, $position='head')
     {
         if (!preg_match('|^https?://|i', $file) && $file[0] != '/') {
-            $file = $this->scripts_path . $file;
-            if ($fs = @filemtime($file)) {
-                $file .= '?s=' . $fs;
-            }
+            $file = $this->file_mod($this->scripts_path . $file);
         }
 
         if (!is_array($this->script_files[$position])) {

--
Gitblit v1.9.1